/**
 */
package tools.descartes.dni.dnimm3ap.impl;

import java.util.Collection;

import java.util.List;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import tools.descartes.dni.dnimm3ap.AdaptableEndPerformance;
import tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance;
import tools.descartes.dni.dnimm3ap.AdaptableLink;
import tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance;
import tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface;
import tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance;
import tools.descartes.dni.dnimm3ap.AdaptableNode;
import tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance;
import tools.descartes.dni.dnimm3ap.AdaptationRepositories;
import tools.descartes.dni.dnimm3ap.DNIAPPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Adaptation Repositories</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getNodes <em>Nodes</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getEndPerformances <em>End Performances</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getIntermediatePerformances <em>Intermediate Performances</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getSdnNodePerformances <em>Sdn Node Performances</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getNetworkInterfaces <em>Network Interfaces</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getNetworkInterfacePerformances <em>Network Interface Performances</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getLinks <em>Links</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getLinkPerformances <em>Link Performances</em>}</li>
 * </ul>
 *
 * @generated
 */
public class AdaptationRepositoriesImpl extends MinimalEObjectImpl.Container implements AdaptationRepositories {
	/**
	 * The cached value of the '{@link #getNodes() <em>Nodes</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNodes()
	 * @generated
	 * @ordered
	 */
	protected EList<AdaptableNode> nodes;

	/**
	 * The cached value of the '{@link #getEndPerformances() <em>End Performances</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEndPerformances()
	 * @generated
	 * @ordered
	 */
	protected EList<AdaptableEndPerformance> endPerformances;

	/**
	 * The cached value of the '{@link #getIntermediatePerformances() <em>Intermediate Performances</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIntermediatePerformances()
	 * @generated
	 * @ordered
	 */
	protected EList<AdaptableIntermediatePerformance> intermediatePerformances;

	/**
	 * The cached value of the '{@link #getSdnNodePerformances() <em>Sdn Node Performances</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSdnNodePerformances()
	 * @generated
	 * @ordered
	 */
	protected EList<AdaptableSdnNodePerformance> sdnNodePerformances;

	/**
	 * The cached value of the '{@link #getNetworkInterfaces() <em>Network Interfaces</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNetworkInterfaces()
	 * @generated
	 * @ordered
	 */
	protected EList<AdaptableNetworkInterface> networkInterfaces;

	/**
	 * The cached value of the '{@link #getNetworkInterfacePerformances() <em>Network Interface Performances</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNetworkInterfacePerformances()
	 * @generated
	 * @ordered
	 */
	protected EList<AdaptableNetworkInterfacePerformance> networkInterfacePerformances;

	/**
	 * The cached value of the '{@link #getLinks() <em>Links</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinks()
	 * @generated
	 * @ordered
	 */
	protected EList<AdaptableLink> links;

	/**
	 * The cached value of the '{@link #getLinkPerformances() <em>Link Performances</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinkPerformances()
	 * @generated
	 * @ordered
	 */
	protected EList<AdaptableLinkPerformance> linkPerformances;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptationRepositoriesImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DNIAPPackage.Literals.ADAPTATION_REPOSITORIES;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<AdaptableNode> getNodes() {
		if (nodes == null) {
			nodes = new EObjectContainmentEList<AdaptableNode>(AdaptableNode.class, this, DNIAPPackage.ADAPTATION_REPOSITORIES__NODES);
		}
		return nodes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<AdaptableEndPerformance> getEndPerformances() {
		if (endPerformances == null) {
			endPerformances = new EObjectContainmentEList<AdaptableEndPerformance>(AdaptableEndPerformance.class, this, DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCES);
		}
		return endPerformances;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<AdaptableIntermediatePerformance> getIntermediatePerformances() {
		if (intermediatePerformances == null) {
			intermediatePerformances = new EObjectContainmentEList<AdaptableIntermediatePerformance>(AdaptableIntermediatePerformance.class, this, DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCES);
		}
		return intermediatePerformances;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<AdaptableSdnNodePerformance> getSdnNodePerformances() {
		if (sdnNodePerformances == null) {
			sdnNodePerformances = new EObjectContainmentEList<AdaptableSdnNodePerformance>(AdaptableSdnNodePerformance.class, this, DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCES);
		}
		return sdnNodePerformances;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<AdaptableNetworkInterface> getNetworkInterfaces() {
		if (networkInterfaces == null) {
			networkInterfaces = new EObjectContainmentEList<AdaptableNetworkInterface>(AdaptableNetworkInterface.class, this, DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACES);
		}
		return networkInterfaces;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<AdaptableNetworkInterfacePerformance> getNetworkInterfacePerformances() {
		if (networkInterfacePerformances == null) {
			networkInterfacePerformances = new EObjectContainmentEList<AdaptableNetworkInterfacePerformance>(AdaptableNetworkInterfacePerformance.class, this, DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCES);
		}
		return networkInterfacePerformances;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<AdaptableLink> getLinks() {
		if (links == null) {
			links = new EObjectContainmentEList<AdaptableLink>(AdaptableLink.class, this, DNIAPPackage.ADAPTATION_REPOSITORIES__LINKS);
		}
		return links;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<AdaptableLinkPerformance> getLinkPerformances() {
		if (linkPerformances == null) {
			linkPerformances = new EObjectContainmentEList<AdaptableLinkPerformance>(AdaptableLinkPerformance.class, this, DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCES);
		}
		return linkPerformances;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NODES:
				return ((InternalEList<?>)getNodes()).basicRemove(otherEnd, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCES:
				return ((InternalEList<?>)getEndPerformances()).basicRemove(otherEnd, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCES:
				return ((InternalEList<?>)getIntermediatePerformances()).basicRemove(otherEnd, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCES:
				return ((InternalEList<?>)getSdnNodePerformances()).basicRemove(otherEnd, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACES:
				return ((InternalEList<?>)getNetworkInterfaces()).basicRemove(otherEnd, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCES:
				return ((InternalEList<?>)getNetworkInterfacePerformances()).basicRemove(otherEnd, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINKS:
				return ((InternalEList<?>)getLinks()).basicRemove(otherEnd, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCES:
				return ((InternalEList<?>)getLinkPerformances()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NODES:
				return getNodes();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCES:
				return getEndPerformances();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCES:
				return getIntermediatePerformances();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCES:
				return getSdnNodePerformances();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACES:
				return getNetworkInterfaces();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCES:
				return getNetworkInterfacePerformances();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINKS:
				return getLinks();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCES:
				return getLinkPerformances();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NODES:
				getNodes().clear();
				getNodes().addAll((Collection<? extends AdaptableNode>)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCES:
				getEndPerformances().clear();
				getEndPerformances().addAll((Collection<? extends AdaptableEndPerformance>)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCES:
				getIntermediatePerformances().clear();
				getIntermediatePerformances().addAll((Collection<? extends AdaptableIntermediatePerformance>)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCES:
				getSdnNodePerformances().clear();
				getSdnNodePerformances().addAll((Collection<? extends AdaptableSdnNodePerformance>)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACES:
				getNetworkInterfaces().clear();
				getNetworkInterfaces().addAll((Collection<? extends AdaptableNetworkInterface>)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCES:
				getNetworkInterfacePerformances().clear();
				getNetworkInterfacePerformances().addAll((Collection<? extends AdaptableNetworkInterfacePerformance>)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINKS:
				getLinks().clear();
				getLinks().addAll((Collection<? extends AdaptableLink>)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCES:
				getLinkPerformances().clear();
				getLinkPerformances().addAll((Collection<? extends AdaptableLinkPerformance>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NODES:
				getNodes().clear();
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCES:
				getEndPerformances().clear();
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCES:
				getIntermediatePerformances().clear();
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCES:
				getSdnNodePerformances().clear();
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACES:
				getNetworkInterfaces().clear();
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCES:
				getNetworkInterfacePerformances().clear();
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINKS:
				getLinks().clear();
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCES:
				getLinkPerformances().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NODES:
				return nodes != null && !nodes.isEmpty();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCES:
				return endPerformances != null && !endPerformances.isEmpty();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCES:
				return intermediatePerformances != null && !intermediatePerformances.isEmpty();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCES:
				return sdnNodePerformances != null && !sdnNodePerformances.isEmpty();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACES:
				return networkInterfaces != null && !networkInterfaces.isEmpty();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCES:
				return networkInterfacePerformances != null && !networkInterfacePerformances.isEmpty();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINKS:
				return links != null && !links.isEmpty();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCES:
				return linkPerformances != null && !linkPerformances.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //AdaptationRepositoriesImpl
